import { Plugin, PluginServiceApi } from "@cloudbase/framework-core";
export interface IFunctionPluginInputs {
    functionRootPath: string;
    functions: any[];
    servicePaths?: Record<string, string>;
}
declare class FunctionPlugin extends Plugin {
    name: string;
    api: PluginServiceApi;
    inputs: IFunctionPluginInputs;
    protected resolvedInputs: any;
    protected buildOutput: any;
    protected functions: any[];
    protected functionRootPath: string;
    constructor(name: string, api: PluginServiceApi, inputs: IFunctionPluginInputs);
    /**
     * 初始化
     */
    init(): Promise<void>;
    compile(): Promise<{
        Resources: any;
    }>;
    /**
     * 删除资源
     */
    remove(): Promise<void>;
    /**
     * 生成代码
     */
    genCode(): Promise<void>;
    /**
     * 构建
     */
    build(): Promise<void>;
    /**
     * 部署
     */
    deploy(): Promise<void>;
    functionConfigToSAM(funcitonConfig: any): {
        Type: string;
        Properties: {
            Handler: any;
            Description: string;
            Runtime: any;
            FunctionName: any;
            MemorySize: any;
            Timeout: any;
            Environment: any;
            VpcConfig: any;
            HttpPath: any;
        };
    };
    toConstantCase(name: string): string;
}
export declare const plugin: typeof FunctionPlugin;
export {};
//# sourceMappingURL=index.d.ts.map